//
//
//  RX3DCZ Николай Козлов
// Скетч предназначен для прошивки Arduino nano,  которая используется для
// преобразования данных получаемых через I2C от AS5600 в имитацию обычного валкодера.

//    DATE:12-10-2022
// использованы примеры из библиотек AS5600.h (Rob Tillaart) и AMS_AS5600.h (v1.2  Скляр Роман S-LAB).
// а так же https://arduino.ru/forum/programmirovanie/imitatsiya-raboty-enkodera-s-pomoshch-arduino
#include "AS5600.h"
#include "Wire.h" //  use default Wire

AS5600 as5600;// Devices class declarations  

#define ENCODER_PIN_A   9// выход имитатора энкодера А -> D9 
#define ENCODER_PIN_B   10//выход имитатора энкодера B ->  D10 
#define JOG_SENS 40       //миллисекунды// Чувствительность на таймере

int tic_encoder = 20 ;   // время замкнутых контактов при имитации энкодера
int step_encoder = 2 ;   //количество шагов магнитного енкодера на 1 шаг обычного

int last_value = 0;      // старое значение данных получяемых по I2C от энкодера
int now_value = 0;      // новое значение данных получяемых по I2C от энкодера
int delta_value = 0;    // разница между старым значением и новым
uint32_t last_time = 150;  // Хранит время для регулировки чувствительности
int raw =0;


//******************************************************************************************************

void setup() {
Serial.begin(19200);
Wire.begin();
as5600.begin();  
as5600.setDirection(AS5600_CLOCK_WISE);  //  устанавливаем программное направление счета - по умолчянию по часовой - увеличение
as5600.setHysteresis(1);
pinMode(ENCODER_PIN_A, OUTPUT);
pinMode(ENCODER_PIN_B, OUTPUT); 
digitalWrite(ENCODER_PIN_A,HIGH);
digitalWrite(ENCODER_PIN_B,HIGH);
/*
  int b = as5600.isConnected();
  Serial.print("Connect: ");
  Serial.println(b);
  */
              }
//******************************************************************************************************
                             
void sensorEvent() {
  if(as5600.isConnected()) {

                           raw = as5600.getAngularSpeed(); //получяем данные о направлении вращения энкодера
                           //(данные о скорости можно использовать)
                           now_value = (as5600.readAngle() * 2 *PI / 4095)*100; // Получаем нынешнее значение от датчика  (от 0 до 4095 )
                           // и преобразуем в диапозон от 0 до 628

     // Serial.print("сырое : ");
    //  Serial.println(now_value);

                           delta_value = abs(now_value - last_value); // Находим разность текущего и прошлого значений
 //      Serial.print("    дельта:  ");
 //      Serial.println(delta_value);

             if(delta_value >= step_encoder) { // если разность болше или равна шагу то идем дальше 
             //(здесь как бы идет еще большее снижение импульсов на 1 оборот энкодера - 628/2=314)
  
                           if (raw > 0) { // Если был поворот по часовой стрелке то Больше
     
Serial.print("Больше : ");
Serial.println(raw);
/*
Serial.print(last_value);
Serial.print("   ");
Serial.print(now_value);
Serial.print("   ");
Serial.println(delta_value);
*/
      pravo(); //имитируем 1 клик в право
                       }


if(raw < 0) { // Если был поворот по часовой стрелке то Меньше
     
Serial.print("Меньше : ");
Serial.println(raw);
/*
Serial.print(last_value);
Serial.print("   ");
Serial.print(now_value);
Serial.print("   ");
Serial.println(delta_value);
*/
      levo();//имитируем 1 клик в лево
            } 
                                              }
last_value = now_value; // Сохраняем нынешнее значение как прошлое
                         }
          }
//***************************************************************************



void levo(){//имитируем поворот в лево
    digitalWrite(ENCODER_PIN_A, LOW);
    delay(tic_encoder);
    digitalWrite(ENCODER_PIN_B, LOW);
    delay(tic_encoder);
    digitalWrite(ENCODER_PIN_A, HIGH);
    delay(tic_encoder);
    digitalWrite(ENCODER_PIN_B, HIGH);
  }
//**************************************************************************
 void pravo(){  //имитируем поворот в право
    digitalWrite(ENCODER_PIN_B, LOW);
    delay(tic_encoder);
    digitalWrite(ENCODER_PIN_A, LOW);
    delay(tic_encoder);
    digitalWrite(ENCODER_PIN_B, HIGH);
    delay(tic_encoder);
    digitalWrite(ENCODER_PIN_A, HIGH);
  }
//*************************************************************************

void loop() {
    sensorEvent(); // Опрос датчика
   // Serial.println(last_time);
   //сопоставвляем скорость вращения энкодера с задержкой опроса датчика
    int abs_raw = abs(raw);// абсолютное значение скорости вращения
    if (abs_raw >=1000) abs_raw=1000; //максимальное значение - выше минимальная задержка
    last_time=map(abs_raw,1,1000,150,0);//
    delay(last_time); // задержка влияет на количество ошибок работы имитатора работы энкодера
            }       
